/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.staat.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="STAAT.UK",
     query="SELECT o FROM Staat o WHERE "

                         + "o"
                +".customCodeStaatsangehoerigkeit"
              +" = ?1"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="STAAT.AllHavingCustomCodeStaat",
     query="SELECT obj FROM Staat obj WHERE obj.customCodeStaat IS NOT NULL",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STAAT.AllHavingCustomCodeStaatsangehoerigkeit",
     query="SELECT obj FROM Staat obj WHERE obj.customCodeStaatsangehoerigkeit IS NOT NULL",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STAAT.AllOrderedByNameStaat",
     query="SELECT obj FROM Staat obj ORDER BY obj.nameStaat",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STAAT.AllOrderedByNameStaatsangehoerigkeit",
     query="SELECT obj FROM Staat obj ORDER BY obj.nameStaatsangehoerigkeit",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STAAT.UniqueCustomCodeStaat",
     query="SELECT obj FROM Staat obj WHERE obj.customCodeStaat = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STAAT.UniqueCustomCodeStaatsangehoerigkeit",
     query="SELECT obj FROM Staat obj WHERE obj.customCodeStaatsangehoerigkeit = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STAAT.UniqueIso3166Alpha2",
     query="SELECT obj FROM Staat obj WHERE obj.iso3166Alpha2 = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STAAT.UniqueNameStaat",
     query="SELECT obj FROM Staat obj WHERE UPPER(obj.nameStaat) LIKE UPPER(?1)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STAAT.UniqueNameStaatsangehoerigkeit",
     query="SELECT obj FROM Staat obj WHERE UPPER(obj.nameStaatsangehoerigkeit) LIKE UPPER(?1)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "STAAT")
// @javax.persistence.IdClass(StaatPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Staat
extends AbstractStaat
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected Staat() {
    super();
  }
    public Staat(de.ivu.elect.jee.entity.customdata.CustomData customData){
                      if (customData != null && de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE != customData) {
          customData.setTechnicalEntity(this);
          customDataStorage = new de.ivu.elect.business.customdata.entity.CustomDataStorage(customData);
        }
            }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Staat(Staat original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "staat_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Staat")
    @javax.persistence.TableGenerator(name = "Staat", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Staat", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient StaatPK pkCache;

  @Override
  public StaatPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new StaatPK(getId());
    }

    return pkCache;
  }

  public static <E extends Staat> java.util.Map<StaatPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<StaatPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Staat> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedCustomCodeStaat = false;
          hasChangedCustomCodeStaatsangehoerigkeit = false;
          hasChangedEuStaat = false;
          hasChangedIso3166Alpha2 = false;
          hasChangedIso3166Numerisch = false;
          hasChangedNameStaat = false;
          hasChangedNameStaatsangehoerigkeit = false;
  
      hasChangedCustomDataStorage = false;
  
    

    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "CODE_STAAT", nullable = StaatConstants.CODE_STAAT_NULLABLE, length=StaatConstants.CODE_STAAT_MAX_LENGTH)
        
  protected java.lang.String customCodeStaat =  null;

  @javax.persistence.Transient
  protected boolean hasChangedCustomCodeStaat = false;

  public boolean hasChangedCustomCodeStaat(){
    return hasChangedCustomCodeStaat;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertCustomCodeStaat = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenCustomCodeStaat;
  
  /**
   * 
   *
   * getter for STAAT.CODE_STAAT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getCustomCodeStaat() {
        return customCodeStaat;
      }

  /**
   * 
   *
   * setter for STAAT.CODE_STAAT
   *
   * @param customCodeStaat
   */
  @Override   public void setCustomCodeStaat(@javax.annotation.Nullable  java.lang.String customCodeStaat) {

       resetTkCache();
                  
                          java.lang.String customCodeStaatInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(customCodeStaat, StaatConstants.CODE_STAAT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.customCodeStaat
      , customCodeStaatInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedCustomCodeStaat |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("customCodeStaat");
      }


             if (!isSeitLadenVeraendertCustomCodeStaat) {
          isSeitLadenVeraendertCustomCodeStaat = thisAttributChanged;
         if (isSeitLadenVeraendertCustomCodeStaat){
           wertNachLadenCustomCodeStaat=this.customCodeStaat;
         }
       }
      

       this.customCodeStaat = customCodeStaatInternal;

         }

        
  @javax.persistence.Column(name = "CODE_STAATSANGEHOERIGKEIT", nullable = StaatConstants.CODE_STAATSANGEHOERIGKEIT_NULLABLE, length=StaatConstants.CODE_STAATSANGEHOERIGKEIT_MAX_LENGTH)
        
  protected java.lang.String customCodeStaatsangehoerigkeit =  null;

  @javax.persistence.Transient
  protected boolean hasChangedCustomCodeStaatsangehoerigkeit = false;

  public boolean hasChangedCustomCodeStaatsangehoerigkeit(){
    return hasChangedCustomCodeStaatsangehoerigkeit;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertCustomCodeStaatsangehoerigkeit = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenCustomCodeStaatsangehoerigkeit;
  
  /**
   * 
   *
   * getter for STAAT.CODE_STAATSANGEHOERIGKEIT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getCustomCodeStaatsangehoerigkeit() {
        return customCodeStaatsangehoerigkeit;
      }

  /**
   * 
   *
   * setter for STAAT.CODE_STAATSANGEHOERIGKEIT
   *
   * @param customCodeStaatsangehoerigkeit
   */
  @Override   public void setCustomCodeStaatsangehoerigkeit(@javax.annotation.Nullable  java.lang.String customCodeStaatsangehoerigkeit) {

       resetTkCache();
                  
                          java.lang.String customCodeStaatsangehoerigkeitInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(customCodeStaatsangehoerigkeit, StaatConstants.CODE_STAATSANGEHOERIGKEIT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.customCodeStaatsangehoerigkeit
      , customCodeStaatsangehoerigkeitInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedCustomCodeStaatsangehoerigkeit |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("customCodeStaatsangehoerigkeit");
      }


             if (!isSeitLadenVeraendertCustomCodeStaatsangehoerigkeit) {
          isSeitLadenVeraendertCustomCodeStaatsangehoerigkeit = thisAttributChanged;
         if (isSeitLadenVeraendertCustomCodeStaatsangehoerigkeit){
           wertNachLadenCustomCodeStaatsangehoerigkeit=this.customCodeStaatsangehoerigkeit;
         }
       }
      

       this.customCodeStaatsangehoerigkeit = customCodeStaatsangehoerigkeitInternal;

         }

        
      @javax.persistence.Column(name = "EU_STAAT", nullable = StaatConstants.EU_STAAT_NULLABLE)
    
  protected java.lang.Boolean euStaat =  false;

  @javax.persistence.Transient
  protected boolean hasChangedEuStaat = false;

  public boolean hasChangedEuStaat(){
    return hasChangedEuStaat;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertEuStaat = false;
     @javax.persistence.Transient
     private transient java.lang.Boolean wertNachLadenEuStaat;
  
  /**
   * 
   *
   * getter for STAAT.EU_STAAT
   */
    @Override   public  java.lang.Boolean getEuStaat() {
        return euStaat;
      }

  /**
   * 
   *
   * setter for STAAT.EU_STAAT
   *
   * @param euStaat
   */
  @Override   public void setEuStaat( java.lang.Boolean euStaat) {

       resetTkCache();
                  java.lang.Boolean euStaatInternal = euStaat;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.euStaat
      , euStaatInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedEuStaat |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("euStaat");
      }


             if (!isSeitLadenVeraendertEuStaat) {
          isSeitLadenVeraendertEuStaat = thisAttributChanged;
         if (isSeitLadenVeraendertEuStaat){
           wertNachLadenEuStaat=this.euStaat;
         }
       }
      

       this.euStaat = euStaatInternal;

         }

        
  @javax.persistence.Column(name = "ISO3166_ALPHA2", nullable = StaatConstants.ISO3166_ALPHA2_NULLABLE, length=StaatConstants.ISO3166_ALPHA2_MAX_LENGTH)
        
  protected java.lang.String iso3166Alpha2 =  null;

  @javax.persistence.Transient
  protected boolean hasChangedIso3166Alpha2 = false;

  public boolean hasChangedIso3166Alpha2(){
    return hasChangedIso3166Alpha2;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertIso3166Alpha2 = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenIso3166Alpha2;
  
  /**
   * 
   *
   * getter for STAAT.ISO3166_ALPHA2
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getIso3166Alpha2() {
        return iso3166Alpha2;
      }

  /**
   * 
   *
   * setter for STAAT.ISO3166_ALPHA2
   *
   * @param iso3166Alpha2
   */
  @Override   public void setIso3166Alpha2(@javax.annotation.Nullable  java.lang.String iso3166Alpha2) {

       resetTkCache();
                  
                          java.lang.String iso3166Alpha2Internal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(iso3166Alpha2, StaatConstants.ISO3166_ALPHA2_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.iso3166Alpha2
      , iso3166Alpha2Internal);

      attributeChanged |= thisAttributChanged;

      hasChangedIso3166Alpha2 |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("iso3166Alpha2");
      }


             if (!isSeitLadenVeraendertIso3166Alpha2) {
          isSeitLadenVeraendertIso3166Alpha2 = thisAttributChanged;
         if (isSeitLadenVeraendertIso3166Alpha2){
           wertNachLadenIso3166Alpha2=this.iso3166Alpha2;
         }
       }
      

       this.iso3166Alpha2 = iso3166Alpha2Internal;

         }

        
  @javax.persistence.Column(name = "ISO3166_NUMERISCH", nullable = StaatConstants.ISO3166_NUMERISCH_NULLABLE, length=StaatConstants.ISO3166_NUMERISCH_MAX_LENGTH)
        
  protected java.lang.String iso3166Numerisch =  null;

  @javax.persistence.Transient
  protected boolean hasChangedIso3166Numerisch = false;

  public boolean hasChangedIso3166Numerisch(){
    return hasChangedIso3166Numerisch;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertIso3166Numerisch = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenIso3166Numerisch;
  
  /**
   * 
   *
   * getter for STAAT.ISO3166_NUMERISCH
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getIso3166Numerisch() {
        return iso3166Numerisch;
      }

  /**
   * 
   *
   * setter for STAAT.ISO3166_NUMERISCH
   *
   * @param iso3166Numerisch
   */
  @Override   public void setIso3166Numerisch(@javax.annotation.Nullable  java.lang.String iso3166Numerisch) {

       resetTkCache();
                  
                          java.lang.String iso3166NumerischInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(iso3166Numerisch, StaatConstants.ISO3166_NUMERISCH_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.iso3166Numerisch
      , iso3166NumerischInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedIso3166Numerisch |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("iso3166Numerisch");
      }


             if (!isSeitLadenVeraendertIso3166Numerisch) {
          isSeitLadenVeraendertIso3166Numerisch = thisAttributChanged;
         if (isSeitLadenVeraendertIso3166Numerisch){
           wertNachLadenIso3166Numerisch=this.iso3166Numerisch;
         }
       }
      

       this.iso3166Numerisch = iso3166NumerischInternal;

         }

        
  @javax.persistence.Column(name = "NAME_STAAT", nullable = StaatConstants.NAME_STAAT_NULLABLE, length=StaatConstants.NAME_STAAT_MAX_LENGTH)
        
  protected java.lang.String nameStaat =  null;

  @javax.persistence.Transient
  protected boolean hasChangedNameStaat = false;

  public boolean hasChangedNameStaat(){
    return hasChangedNameStaat;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertNameStaat = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenNameStaat;
  
  /**
   * 
   *
   * getter for STAAT.NAME_STAAT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getNameStaat() {
        return nameStaat;
      }

  /**
   * 
   *
   * setter for STAAT.NAME_STAAT
   *
   * @param nameStaat
   */
  @Override   public void setNameStaat(@javax.annotation.Nullable  java.lang.String nameStaat) {

       resetTkCache();
                  
                          java.lang.String nameStaatInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(nameStaat, StaatConstants.NAME_STAAT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.nameStaat
      , nameStaatInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedNameStaat |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("nameStaat");
      }


             if (!isSeitLadenVeraendertNameStaat) {
          isSeitLadenVeraendertNameStaat = thisAttributChanged;
         if (isSeitLadenVeraendertNameStaat){
           wertNachLadenNameStaat=this.nameStaat;
         }
       }
      

       this.nameStaat = nameStaatInternal;

         }

        
  @javax.persistence.Column(name = "NAME_STAATSANGEHOERIGKEIT", nullable = StaatConstants.NAME_STAATSANGEHOERIGKEIT_NULLABLE, length=StaatConstants.NAME_STAATSANGEHOERIGKEIT_MAX_LENGTH)
        
  protected java.lang.String nameStaatsangehoerigkeit =  null;

  @javax.persistence.Transient
  protected boolean hasChangedNameStaatsangehoerigkeit = false;

  public boolean hasChangedNameStaatsangehoerigkeit(){
    return hasChangedNameStaatsangehoerigkeit;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertNameStaatsangehoerigkeit = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenNameStaatsangehoerigkeit;
  
  /**
   * 
   *
   * getter for STAAT.NAME_STAATSANGEHOERIGKEIT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getNameStaatsangehoerigkeit() {
        return nameStaatsangehoerigkeit;
      }

  /**
   * 
   *
   * setter for STAAT.NAME_STAATSANGEHOERIGKEIT
   *
   * @param nameStaatsangehoerigkeit
   */
  @Override   public void setNameStaatsangehoerigkeit(@javax.annotation.Nullable  java.lang.String nameStaatsangehoerigkeit) {

       resetTkCache();
                  
                          java.lang.String nameStaatsangehoerigkeitInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(nameStaatsangehoerigkeit, StaatConstants.NAME_STAATSANGEHOERIGKEIT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.nameStaatsangehoerigkeit
      , nameStaatsangehoerigkeitInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedNameStaatsangehoerigkeit |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("nameStaatsangehoerigkeit");
      }


             if (!isSeitLadenVeraendertNameStaatsangehoerigkeit) {
          isSeitLadenVeraendertNameStaatsangehoerigkeit = thisAttributChanged;
         if (isSeitLadenVeraendertNameStaatsangehoerigkeit){
           wertNachLadenNameStaatsangehoerigkeit=this.nameStaatsangehoerigkeit;
         }
       }
      

       this.nameStaatsangehoerigkeit = nameStaatsangehoerigkeitInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu CustomDataStorage
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "CUSTOM_DATA_STORAGE_ID", referencedColumnName="CUSTOM_DATA_STORAGE_ID"))
  protected de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage;

  /**
   * 
   */
  @Override
  public void setCustomDataStorage(@javax.annotation.Nullable  de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.customDataStorage
    , customDataStorage);

    attributeChanged |= thisAttributChanged;

    hasChangedCustomDataStorage |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("customDataStorage");
    }

    this.customDataStorage = customDataStorage;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.customdata.entity.CustomDataStorage getCustomDataStorage(){
    return this.customDataStorage;
  }

  @javax.persistence.Transient
  protected boolean hasChangedCustomDataStorage = false;

  public boolean hasChangedCustomDataStorage(){
    return hasChangedCustomDataStorage;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Staat:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Staat other){
                             other.customCodeStaat = this.customCodeStaat;
                                other.customCodeStaatsangehoerigkeit = this.customCodeStaatsangehoerigkeit;
                                other.euStaat = this.euStaat;
                                other.iso3166Alpha2 = this.iso3166Alpha2;
                                other.iso3166Numerisch = this.iso3166Numerisch;
                                other.nameStaat = this.nameStaat;
                                other.nameStaatsangehoerigkeit = this.nameStaatsangehoerigkeit;
           
  other.setCustomDataStorage(this.getCustomDataStorage());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Staat.class)){
        copyEntityAttributesUsingSetter((Staat) other.castTo(Staat.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Staat: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Staat other){
               other.setCustomCodeStaat(this.customCodeStaat);
                  other.setCustomCodeStaatsangehoerigkeit(this.customCodeStaatsangehoerigkeit);
                  other.setEuStaat(this.euStaat);
                  other.setIso3166Alpha2(this.iso3166Alpha2);
                  other.setIso3166Numerisch(this.iso3166Numerisch);
                  other.setNameStaat(this.nameStaat);
                  other.setNameStaatsangehoerigkeit(this.nameStaatsangehoerigkeit);
           other.setCustomDataXml(this.getCustomDataXml());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Staat other){
                       if (hasChangedCustomCodeStaat) {
        other.setCustomCodeStaat(this.customCodeStaat);
      }
                             if (hasChangedCustomCodeStaatsangehoerigkeit) {
        other.setCustomCodeStaatsangehoerigkeit(this.customCodeStaatsangehoerigkeit);
      }
                             if (hasChangedEuStaat) {
        other.setEuStaat(this.euStaat);
      }
                             if (hasChangedIso3166Alpha2) {
        other.setIso3166Alpha2(this.iso3166Alpha2);
      }
                             if (hasChangedIso3166Numerisch) {
        other.setIso3166Numerisch(this.iso3166Numerisch);
      }
                             if (hasChangedNameStaat) {
        other.setNameStaat(this.nameStaat);
      }
                             if (hasChangedNameStaatsangehoerigkeit) {
        other.setNameStaatsangehoerigkeit(this.nameStaatsangehoerigkeit);
      }
             }




    /**
    * Hat die Entität überhaupt einen CustomDataStorage?
    */
    private boolean isCustomDataSupported() {
      return getCustomDataStorage()!=null;
    }

    @Override
    public de.ivu.elect.jee.entity.customdata.CustomData getCustomData() {
      if (isCustomDataSupported()) {
        de.ivu.elect.jee.entity.customdata.CustomData result = getCustomDataStorage().getCustomData();
        result.setTechnicalEntity(this); // Fachliche Entität bei jedem Zugriff setzen
        return result;
      }
      return de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE;
    }


    @Override
    @SuppressWarnings("unchecked")
    public <T extends de.ivu.elect.jee.entity.customdata.CustomData> T getCustomData(Class<T> clazz) {
      if (isCustomDataSupported()) {
        return (T) getCustomData();
      }
      throw new IllegalStateException("Entität Staat besitzt kein CustomDataStorage: "+this);
    }


    @Override
    public void updateCustomData() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().updateCustomData();
      }
    }


    public void clearCustomDataCache() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().clearCustomDataCache();
      }
    }

    public String getCustomDataXml(){
      if (isCustomDataSupported()) {
        return getCustomDataStorage().getCustomDataXml();
      }
      return "";
    }

    public void setCustomDataXml(String customDataXml){
      if (isCustomDataSupported()) {
        if (org.apache.commons.lang3.StringUtils.isBlank(customDataXml)) {
          if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
            throw new IllegalStateException("Entität Staat hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
          }
          // ELECTMUC-2581
          System.err.println("Entität Staat hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
        } else {
          getCustomDataStorage().setCustomDataXml(customDataXml);
        }
        clearCustomDataCache(); // WASDE-1131
      } else {
       if (org.apache.commons.lang3.StringUtils.isNotBlank(customDataXml)) {
         if (customDataXml.endsWith("EmptyCustomData/>")) {
            // Abwärtskompatibilität...alles gut, die alten, leeren CustomDataObjekte...
         } else {
           if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
             throw new IllegalStateException("Entität Staat hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
           }
           // ELECT-5122
           System.err.println("Entität Staat hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
         }
       }
      }
    }

    public boolean hasChangedCustomDataXml() {
      if (isCustomDataSupported()) {
        return getCustomDataStorage().hasChangedCustomDataXml();
      }
      return false;
    }


    @javax.persistence.Transient
    private transient StaatTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public StaatTK getStaatTK(){
    if (tkCache==null) {
    tkCache = new StaatTK(

getCustomCodeStaat()
, getCustomCodeStaatsangehoerigkeit()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getStaatTK();
    }

  @Override
  public StaatUK getUk(){
    return getStaatUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Staat.class;
  }

public StaatUK getStaatUK(){

   return  new StaatUK(

getCustomCodeStaatsangehoerigkeit()


  );
}

  @javax.persistence.Transient
  private transient StaatProperties properties;

  public StaatProperties getProperties(){
    if (properties == null) {
      properties = new StaatProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public StaatProperties getStaatProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return StaatConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(StaatConstants.MESSAGE_KEY_CODE_STAAT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StaatConstants.MESSAGE_KEY_CODE_STAAT_EINZAHL);

        customCodeStaat =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StaatConstants.MESSAGE_KEY_CODE_STAATSANGEHOERIGKEIT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StaatConstants.MESSAGE_KEY_CODE_STAATSANGEHOERIGKEIT_EINZAHL);

        customCodeStaatsangehoerigkeit =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StaatConstants.MESSAGE_KEY_EU_STAAT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StaatConstants.MESSAGE_KEY_EU_STAAT_EINZAHL);

        euStaat =
     vorher.getAttributTyp().getValueAsBoolean(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StaatConstants.MESSAGE_KEY_ISO3166_ALPHA2_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StaatConstants.MESSAGE_KEY_ISO3166_ALPHA2_EINZAHL);

        iso3166Alpha2 =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StaatConstants.MESSAGE_KEY_ISO3166_NUMERISCH_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StaatConstants.MESSAGE_KEY_ISO3166_NUMERISCH_EINZAHL);

        iso3166Numerisch =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StaatConstants.MESSAGE_KEY_NAME_STAAT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StaatConstants.MESSAGE_KEY_NAME_STAAT_EINZAHL);

        nameStaat =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StaatConstants.MESSAGE_KEY_NAME_STAATSANGEHOERIGKEIT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StaatConstants.MESSAGE_KEY_NAME_STAATSANGEHOERIGKEIT_EINZAHL);

        nameStaatsangehoerigkeit =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertCustomCodeStaat) {
      result.put(StaatConstants.MESSAGE_KEY_CODE_STAAT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenCustomCodeStaat , customCodeStaat));
    }
                            if (isSeitLadenVeraendertCustomCodeStaatsangehoerigkeit) {
      result.put(StaatConstants.MESSAGE_KEY_CODE_STAATSANGEHOERIGKEIT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenCustomCodeStaatsangehoerigkeit , customCodeStaatsangehoerigkeit));
    }
                            if (isSeitLadenVeraendertEuStaat) {
      result.put(StaatConstants.MESSAGE_KEY_EU_STAAT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.BOOLEAN
                , wertNachLadenEuStaat , euStaat));
    }
                            if (isSeitLadenVeraendertIso3166Alpha2) {
      result.put(StaatConstants.MESSAGE_KEY_ISO3166_ALPHA2_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenIso3166Alpha2 , iso3166Alpha2));
    }
                            if (isSeitLadenVeraendertIso3166Numerisch) {
      result.put(StaatConstants.MESSAGE_KEY_ISO3166_NUMERISCH_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenIso3166Numerisch , iso3166Numerisch));
    }
                            if (isSeitLadenVeraendertNameStaat) {
      result.put(StaatConstants.MESSAGE_KEY_NAME_STAAT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenNameStaat , nameStaat));
    }
                            if (isSeitLadenVeraendertNameStaatsangehoerigkeit) {
      result.put(StaatConstants.MESSAGE_KEY_NAME_STAATSANGEHOERIGKEIT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenNameStaatsangehoerigkeit , nameStaatsangehoerigkeit));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertCustomCodeStaat = false;
      wertNachLadenCustomCodeStaat = null;
                          isSeitLadenVeraendertCustomCodeStaatsangehoerigkeit = false;
      wertNachLadenCustomCodeStaatsangehoerigkeit = null;
                          isSeitLadenVeraendertEuStaat = false;
      wertNachLadenEuStaat = null;
                          isSeitLadenVeraendertIso3166Alpha2 = false;
      wertNachLadenIso3166Alpha2 = null;
                          isSeitLadenVeraendertIso3166Numerisch = false;
      wertNachLadenIso3166Numerisch = null;
                          isSeitLadenVeraendertNameStaat = false;
      wertNachLadenNameStaat = null;
                          isSeitLadenVeraendertNameStaatsangehoerigkeit = false;
      wertNachLadenNameStaatsangehoerigkeit = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "STAAT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Staat";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StaatConstants.CODE_STAAT_MAX_LENGTH ,  customCodeStaat, this, StaatConstants.MESSAGE_KEY_CODE_STAAT_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StaatConstants.CODE_STAATSANGEHOERIGKEIT_MAX_LENGTH ,  customCodeStaatsangehoerigkeit, this, StaatConstants.MESSAGE_KEY_CODE_STAATSANGEHOERIGKEIT_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(euStaat, this, StaatConstants.MESSAGE_KEY_EU_STAAT_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StaatConstants.ISO3166_ALPHA2_MAX_LENGTH ,  iso3166Alpha2, this, StaatConstants.MESSAGE_KEY_ISO3166_ALPHA2_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StaatConstants.ISO3166_NUMERISCH_MAX_LENGTH ,  iso3166Numerisch, this, StaatConstants.MESSAGE_KEY_ISO3166_NUMERISCH_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StaatConstants.NAME_STAAT_MAX_LENGTH ,  nameStaat, this, StaatConstants.MESSAGE_KEY_NAME_STAAT_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StaatConstants.NAME_STAATSANGEHOERIGKEIT_MAX_LENGTH ,  nameStaatsangehoerigkeit, this, StaatConstants.MESSAGE_KEY_NAME_STAATSANGEHOERIGKEIT_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
